﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GridView;
using CRUID.Web;

namespace CRUID
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();
		}

		private void customerDomainDataSource_LoadedData(object sender, System.Windows.Controls.LoadedDataEventArgs e)
		{

			if (e.HasError)
			{
				System.Windows.MessageBox.Show(e.Error.ToString(), "Load Error", System.Windows.MessageBoxButton.OK);
				e.MarkErrorAsHandled();
			}
		}

		private void Button_Click(object sender, RoutedEventArgs e)
		{
			gvCustomers.BeginInsert();
		}

		private void gvCustomers_RowEditEnded(object sender, GridViewRowEditEndedEventArgs e)
		{
			if (e.EditAction == GridViewEditAction.Commit)
			{
				customerDomainDataSource.SubmitChanges();
			}
		}

		private void Button_Click_1(object sender, RoutedEventArgs e)
		{
			if (gvCustomers.SelectedItem == null)
			{
				gvCustomers.SelectedItems.Add(gvCustomers.Items[0]);
			}

			gvCustomers.BeginEdit();
		}

		private void Button_Click_2(object sender, RoutedEventArgs e)
		{
			Button b = sender as Button;
			Customer customerToDelete = b.DataContext as Customer;
			gvCustomers.Items.Remove(customerToDelete);
			customerDomainDataSource.SubmitChanges();
		}

		private void customerDomainDataSource_SubmittedChanges(object sender, SubmittedChangesEventArgs e)
		{
			if (e.HasError)
			{
				// we cannot delete a customer which has an order, so we handle the exception just for the test
				e.MarkErrorAsHandled();
			}
		}
	}
}
